/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: Matrix.cc 9301 2009-09-03 16:38:00Z gawrilow $
*/

#define DIMENSION_CHECKS 1
#define INDEX_CHECKS 1

#include <polymake.h>
#include <Matrix.h>
#include <Rational.h>
#include <Integer.h>
#include <Vector.h>
#include <SparseMatrix.h>
#include <Set.h>
#include <IncidenceMatrix.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::Transposed<pm::Matrix<Rational> > >);
   OperatorInstance4perl(Unary_not, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Integer > >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< double > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const SparseMatrix< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< int > >, perl::Canned< const Matrix< int > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::MatrixMinor<pm::Matrix<Rational> const&, pm::Set<int, pm::operations::cmp> const&, pm::Series<int, true> const&> >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const Matrix< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Matrix< double > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< double > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational>&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >, perl::Canned< const Matrix< Rational > >);
   DisabledFunction4perl(:mul, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< double > >);
   DisabledFunction4perl(:mul, perl::Canned< const Matrix< double > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< double > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const Matrix< Integer > >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Integer > >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(BinaryAssign_div, perl::Canned< Matrix< Integer > >, perl::Canned< const pm::RowChain<pm::Matrix<pm::Integer> const&, pm::Matrix<pm::Integer> const&> >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   OperatorInstance4perl(convert, Matrix< double >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(assign, Matrix< double >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(assign, Matrix< double >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Integer > >, int);
   OperatorInstance4perl(Binary_mul, int, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const pm::ColChain<pm::Matrix<pm::Integer> const&, pm::Matrix<pm::Integer> const&> >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(convert, Matrix< double >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   OperatorInstance4perl(assign, Matrix< Rational >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   OperatorInstance4perl(BinaryAssign_div, perl::Canned< Matrix< Integer > >, perl::Canned< const Vector< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::ColChain<pm::ColChain<pm::Matrix<pm::Integer> const&, pm::Matrix<pm::Integer> const&> const&, pm::Matrix<pm::Integer> const&> >, perl::Canned< const pm::ColChain<pm::ColChain<pm::Matrix<pm::Integer> const&, pm::Matrix<pm::Integer> const&> const&, pm::Matrix<pm::Integer> const&> >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> const&, pm::SingleRow<pm::Vector<pm::Rational> const&> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Integer > >, perl::Canned< const SparseMatrix< Integer, NonSymmetric > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Integer > >, perl::Canned< const pm::Transposed<pm::Matrix<pm::Integer> > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< double > >, perl::Canned< const pm::Transposed<pm::Matrix<double> > >);
   OperatorInstance4perl(Unary_not, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(convert, Matrix< Integer >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const Matrix< int > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::Matrix<pm::Rational> const&, pm::SingleRow<pm::Vector<pm::Rational> const&> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix<pm::Rational>&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::Matrix<pm::Rational> const&, pm::Matrix<pm::Rational> const&> >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::RowChain<pm::Matrix<pm::Rational> const&, pm::Matrix<pm::Rational> const&> const&, pm::Matrix<pm::Rational> const&> >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
