/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: Vector.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#define DIMENSION_CHECKS 1
#define INDEX_CHECKS 1

#include <polymake.h>
#include <Vector.h>
#include <Rational.h>
#include <Integer.h>
#include <SparseVector.h>
#include <Matrix.h>
#include <linalg.h>
#include <Array.h>
#include <IncidenceMatrix.h>
#include <Set.h>
#include <SparseMatrix.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< double > >, perl::Canned< const Vector< double > >);
   OperatorInstance4perl(BinaryAssign_div, perl::Canned< Vector< double > >, int);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< int > >, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< Rational > >, perl::Canned< const SparseVector< Rational > >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const pm::IndexedSlice<pm::Vector<double>&, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Vector< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Vector< double > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Vector< double > >, perl::Canned< const Vector< double > >);
   OperatorInstance4perl(Binary_add, perl::Canned< const Vector< int > >, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(convert, Vector< Integer >, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(convert, Vector< double >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(assign, Vector< double >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Vector< int > >, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(Binary__ne, perl::Canned< const Vector< int > >, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Vector< Rational > >, int);
   OperatorInstance4perl(Binary_mul, int, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Vector< Integer > >, perl::Canned< const Integer >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< Rational > >, perl::Canned< const Vector< double > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Vector< Integer > >, perl::Canned< const Vector< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Vector< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Vector< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational>&>, pm::Series<int, true>, void> >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational>&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<int>&>, pm::Series<int, true>, void>, perl::Canned< const pm::SameElementVector<int> >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Integer>&>, pm::Series<int, false>, void> >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<int>&>, pm::Series<int, true>, void>, perl::Canned< const Vector< int > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<int> const&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational>&>, pm::Series<int, true>, void>, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Integer>&>, pm::Series<int, true>, void> >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary_add, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<double>&>, pm::Series<int, true>, void>, perl::Canned< const Vector< double > >);
   OperatorInstance4perl(Unary_neg, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational>&>, pm::Series<int, true>, void>, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary__or, perl::Canned< const Vector< Rational > >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::sparse2d::traits_base<pm::nothing, true, false, (pm::sparse2d::restriction_kind)0>, false, (pm::sparse2d::restriction_kind)0> > const&> const&, pm::Series<int, true> const&> >);
   OperatorInstance4perl(assign, pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational>&>, pm::Series<int, true>, void>, perl::Canned< const pm::SameElementSparseVector<pm::SingleElementSet<int>, pm::Rational> >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<pm::Rational> const&>, pm::Series<int, true>, void> >, perl::Canned< const Rational >);
   OperatorInstance4perl(Binary__or, perl::Canned< const Vector< Rational > >, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >);
   OperatorInstance4perl(Binary__or, int, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Vector< Rational > >, perl::Canned< const pm::VectorChain<pm::SingleElementVector<pm::Rational>, pm::Vector<pm::Rational> const&> >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Vector< int > >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix_base<int> const&>, pm::Series<int, true>, void> >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
