/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: auto-minor.cc 9298 2009-09-02 23:10:56Z gawrilow $
*/

#define INDEX_CHECKS 1

#include <polymake.h>
#include <Matrix.h>
#include <Rational.h>
#include <Array.h>
#include <Set.h>
#include <IncidenceMatrix.h>
#include <SparseMatrix.h>
#include <Integer.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0, typename T1, typename T2>
   FunctionInterface4perl( minor_X_X_f5, T0,T1,T2 ) {
      perl::Value arg0(stack[0]), arg1(stack[1]), arg2(stack[2]);
      WrapperReturnLvalue( T0, arg0.get<T0>().minor(arg1.get<T1>(), arg2.get<T2>()) );
   };

   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::RowChain<pm::Matrix<Rational> const&, pm::Matrix<Rational> const&> >, perl::Enum<pm::all_selector>, perl::TryCanned< const Array< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::RowChain<pm::Matrix<double> const&, pm::Matrix<double> const&> >, perl::Enum<pm::all_selector>, perl::TryCanned< const Array< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const Set< int > >, perl::TryCanned< const Array< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::RowChain<pm::Matrix<Rational> const&, pm::Matrix<Rational> const&> >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::RowChain<pm::Matrix<double> const&, pm::Matrix<double> const&> >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const Set< int > >, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const Set< int > >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< double > >, perl::Canned< const Set< int > >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const SparseMatrix< Rational > >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::TryCanned< const Array< int > >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< Rational > >, perl::Canned< const Set< int > >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::RowChain<pm::SparseMatrix<pm::Rational, pm::NonSymmetric> const&, pm::Matrix<pm::Rational> const&> >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >, perl::Canned< const pm::Series<int, true> >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< Integer > >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< Integer > >, perl::Enum<pm::all_selector>, perl::TryCanned< const Array< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Enum<pm::all_selector>, perl::Canned< const Set< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< Rational > >, perl::Enum<pm::all_selector>, perl::TryCanned< const Array< int > >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< double > >, perl::Canned< const pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::sparse2d::traits_base<pm::nothing, true, false, (pm::sparse2d::restriction_kind)0>, false, (pm::sparse2d::restriction_kind)0> > const&> >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::sparse2d::traits_base<pm::nothing, true, false, (pm::sparse2d::restriction_kind)0>, false, (pm::sparse2d::restriction_kind)0> > const&> >, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< Matrix< Rational > >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Enum<pm::all_selector>, perl::Canned< const pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::all_selector const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >, perl::Canned< const Set< int > >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> >, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> >, perl::Enum<pm::all_selector>);
   FunctionInstance4perl(minor_X_X_f5, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> >, perl::Canned< const pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
